#!/usr/bin/perl -w

sub setqhead
{
  local($f) = shift;
  local($magic,$dspc,$res);
  $res = -1;

  open(F,$f) || die "Can't open your file $f ".$!;
  seek(F,-8,2);
  read(F,$buf,8);
  ($magic,$dspc) = unpack("a4N",$buf);
  if($magic eq "XTcc")
  {
    $hdr = pack("NccNN",tell(F),0,1,$dspc,0);
    $res = syscall(3,0x46,0,0,-1,fileno(F),$hdr);
  }
  else
  {
    die "Bad magic\n";
  }
  close F;
  $res;
}

$fn = shift || "ram2_unz532xQ.exe";
system ($fn) unless &setqhead($fn);
